---
id: contribute
title: Contribution
---
# Darkroom - Contributing

Darkroom `github.com/gojek/darkroom` is an open-source project. 
It is licensed using the [MIT License][1]. 
We appreciate pull requests; here are our guidelines:

1.  [File an issue][2] 
    (if there isn't one already). If your patch
    is going to be large it might be a good idea to get the
    discussion started early.  We are happy to discuss it in a
    new issue beforehand, and you can always email
    <foss+tech@go-jek.com> about future work.

2.  Please use [Effective Go Community Guidelines][3].

3.  We ask that you squash all the commits together before
    pushing and that your commit message references the bug.

## Issue Reporting
- Check that the issue has not already been reported.
- Be clear, concise and precise in your description of the problem.
- Open an issue with a descriptive title and a summary in grammatically correct,
  complete sentences.
- Include any relevant code to the issue summary.

## Pull Requests
- Please read this [how to GitHub][4] blog post.
- Use a topic branch to easily amend a pull request later, if necessary.
- Write [good commit messages][5].
- Use the same coding conventions as the rest of the project.
- Open a [pull request][6] that relates to *only* one subject with a clear title
  and description in grammatically correct, complete sentences.

Much Thanks! ❤❤❤

GO-JEK Tech

[1]: https://opensource.org/licenses/MIT
[2]: https://github.com/gojek/darkroom/issues
[3]: https://golang.org/doc/effective_go.html
[4]: http://gun.io/blog/how-to-github-fork-branch-and-pull-request
[5]: http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html
[6]: https://help.github.com/articles/using-pull-requests
